<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

    <title>Practical git</title>

    <meta name="description" content="ESTP 2023 course, day 2: Practical git">
    <meta name="author" content="Ole Mussmann">

    <link rel="icon" type="image/x-icon" href="./files/favicon-32x32.png">

    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">

    <meta name="viewport" content="width=device-width, initial-scale=1.0">

    <link rel="stylesheet" href="dist/reset.css">
    <link rel="stylesheet" href="dist/reveal.css">

    <!-- theme -->
    <link rel="stylesheet" href="dist/theme/black.css" id="theme">
    <link rel="stylesheet" href="dist/theme/escience_4.3.1.css" id="theme">

    <!-- fonts -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Nunito">
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Assistant">
    <link rel="stylesheet" href="https://fonts.googleapis.com/icon?family=Material+Icons">

    <!-- Theme used for syntax highlighted code -->
    <link rel="stylesheet" href="plugin/highlight/monokai.css">

    <!-- Load jQuery -->
    <script
      src="https://code.jquery.com/jquery-3.4.1.min.js"
      integrity="sha256-CSXorXvZcTkaix6Yvo6HppcZGetbYMGWSFlBw8HfCJo="
      crossorigin="anonymous"></script>
    <script src="http://localhost:35729/livereload.js"></script>

  </head>
  <body>
    <div class="reveal">
      <div class="slides">

        <section data-markdown data-state="blue_overlay 9 yellow_flag yellow_strip purple_half_circle_bottom purple_blob right_e_top" data-background-video="./files/Bird - 63574.mp4" data-background-video-loop data-background-video-muted="true">
<!-- https://pixabay.com/videos/bird-tit-blue-tit-plumage-pen-63574/ -->
<textarea data-template>

# Practical git

<br>
<br>

<a href="mailto:o.mussmann@esciencecenter.nl">Ole Mussmann</a> | <a href="https://www.esciencecenter.nl/">eScience Center</a> | <img style="height: 2.5vw; padding: 0 .5vw; margin-bottom: -.5vw; margin-top: -2vw;" src="./files/eu_logo.png"><img style="height: 2vw; margin-bottom: -.5vw; margin-top: -2vw;" src="./files/logo_icon.jpg">

</textarea>
</section>
<section data-markdown data-state="standard" data-background="./files/checklist-2589418_1920.jpg">
<!-- https://pixabay.com/photos/checklist-goals-box-notebook-pen-2589418/ -->
<textarea data-template>

## Table of Contents

<div style="width: 24%; float: left; font-size: x-large;">
  <ul>
    <li><a href="#/why">0. Why learn CLI git</a></li>
    <li><a href="#/first_steps">1. First steps with git</a></li>
    <ul>
      <li><a href="#/config">Config</a></li>
      <li><a href="#/init">New repo</a></li>
      <li><a href="#/add">Add stuff</a></li>
      <li><a href="#/commit/0">Committing</a></li>
      <ul>
        <li><a href="#/commit_style">Commit Style</a></li>
      </ul>
      <li><a href="#/push">Pushing</a></li>
      <li><a href="#/realms/3">The five realms</a></li>
    </ul>
  </ul>
</div>
<div style="border-left:1px solid #000; height:25vh; float: left;"></div>
<div style="width: 29%; float: left; font-size: x-large;">
  <ul>
    <li><a href="#/everyday">2. Everyday git</a></li>
    <ul>
      <li><a href="#/status">Status</a></li>
      <li><a href="#/rm">Remove stuff</a></li>
      <li><a href="#/gitignore">Ignore stuff</a></li>
      <li><a href="#/external">External repos</a></li>
      <li><a href="#/branch_1">Branches</a></li>
      <ul>
        <li><a href="#/branch_style">Branch Style</a></li>
        <li><a href="#/detached">Detached HEAD</a></li>
      </ul>
      <li><a href="#/merge">Merging</a></li>
      <li><a href="#/tag">Tags</a></li>
    </ul>
  </ul>
</div>
<div style="border-left:1px solid #000; height:25vh; float: left;"></div>
<div style="width: 30%; float: left; font-size: x-large;">
  <ul>
    <li><a href="#/advanced">3. Advanced git</a></li>
    <ul>
      <li><a href="#/status_2">Advanced status</a></li>
      <li><a href="#/stash">Stash</a></li>
      <li><a href="#/conflicts">Resolve conflicts</a></li>
    </ul>
    <br>
    <li><a href="#/undo">4. Turn back time</a></li>
    <ul>
      <li><a href="#/undo_1">Undo 1 extra commit</a></li>
      <li><a href="#/undo_2">Undo 2 WORKSPACE</a></li>
      <li><a href="#/undo_3">Undo 3 INDEX</a></li>
      <li><a href="#/undo_4">Undo 4 REPO 💀</a></li>
    </ul>
  </ul>
</div>
<div style="border-left:1px solid #000; height:25vh; float: left;"></div>
<div style="width: 15%; float: left; font-size: x-large;">
  <ul>
  <li><a href="#/summary">Summary</a></li>
  <li><a href="#/links">Links</a></li>
  <li><a href="#/exercise">Exercise</a></li>
</ul>
<div>

Notes: Long ToC: encyclopedia for you


</textarea>
</section>
<section data-markdown data-state="standard 6" data-background="./files/notebook-2178656_1280.jpg" id="why">
<!-- https://pixabay.com/photos/notebook-hand-pen-write-writing-2178656/ -->
<textarea data-template>

# Why Learn CLI git?

- All the power! ⚡
- No abstraction layer 🧅
- If you know CLI git, you can figure out GUIs 💡

</textarea>
</section>

<section>
<section data-markdown data-state="standard 7" data-background="./files/cat-727266_1280.jpg" id="first_steps">
<!-- https://pixabay.com/photos/cat-family-pet-love-happy-animal-727266/ -->
<textarea data-template>

# First Steps

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/cat-727266_1280.jpg" id="config">
<!-- https://pixabay.com/photos/cat-family-pet-love-happy-animal-727266/ -->
<textarea data-template>

## Config

<pre data-id="code-animation"><code data-trim class="bash">
# Mandatory (for anything more than clone)
git config --global user.name "Your Full Name"
git config --global user.email your@email.com

# Recommended
git config --global init.defaultBranch main

# Optional
git config --global merge.tool "meld"  # see [1] for options
git config --global core.editor "vim"  # see [2] for options

# List all set options
git config --list --show-origin
</code></pre>

Extensive config options:<br>
https://git-scm.com/book/en/v2/Customizing-Git-Git-Configuration#_git_config

<footer>
[1] git mergetool --tool-help
<br>
[2] <a href="https://git-scm.com/book/en/v2/Appendix-C:-Git-Commands-Setup-and-Config#ch_core_editor">https://git-scm.com/book/en/v2/Appendix-C:-Git-Commands-Setup-and-Config#ch_core_editor</a>
</footer>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/cat-727266_1280.jpg" id="init">
<!-- https://pixabay.com/photos/cat-family-pet-love-happy-animal-727266/ -->
<textarea data-template>

## New Repo

<pre data-id="code-animation"><code data-trim class="bash">
    git init                        # or ...
    git init --initial-branch=main  # if init.defaultBranch is not set
</code></pre>

- Creates a hidden `.git` folder
- The current folder is now your **workspace**

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/cat-727266_1280.jpg" id="add">
<!-- https://pixabay.com/photos/cat-family-pet-love-happy-animal-727266/ -->
<textarea data-template>

## Add Stuff

<pre data-id="code-animation"><code data-trim class="bash">
    git add file
    git add folder
    git add *.txt
    git add .
</code></pre>

- Add files and directories to a mysterious **index**
  - a.k.a. **staging area**
- Empty folders will be ignored
  - Prevent this by adding an empty, hidden file, e.g. ".gitkeep"

Technically, you add _changes_, like the change of adding a file. Or editing a file. Even the change of removing a file.

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/cat-727266_1280.jpg" id="commit">
<!-- https://pixabay.com/photos/cat-family-pet-love-happy-animal-727266/ -->
<textarea data-template>

## Committing

Commit: a set of previously added, related changes

<div class="fragment">
  <pre data-id="code-animation"><code data-trim class="bash">
      git commit -m "fix server crash, resolve #5"  # shortcut, only header
      git commit  # extended version, editor opens, enter header and message
  </code></pre>

  <ul>
    <li>Commit changes to the <b>local repository</b></li>
    <li>Referenced bugs will be closed on Git{Hub,Lab}, if pushed to the <b>upstream repository</b>!</li>
    <ul>
      <li>Use any of <b>close #5, closes #5, closed #5, fix #5, fixes #5, fixed #5, resolve #5, resolves #5, resolved #5</b></li>
    </ul>
  </ul>
</div>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/cat-727266_1280.jpg" id="commit_style">
<!-- https://pixabay.com/photos/cat-family-pet-love-happy-animal-727266/ -->
<textarea data-template>

### Commit Style

- Write meaningful commit messages
- Use imperative: change config, remove file, add tests
- Header should be 50 chars or less, message can be longer
- Make atomic commits!<sup>[1]</sup>
  - Commits can span multiple files, but should have _one_ function, like
    - Add tests to module xyz
    - Use new house-style
    - Introduce logging

<footer>[1] atomic: a single irreducible unit or component in a larger system</footer>

</textarea>
</section>
<section data-markdown data-state="standard" data-background="./files/cat-727266_1280.jpg" id="push">
<!-- https://pixabay.com/photos/cat-family-pet-love-happy-animal-727266/ -->
<textarea data-template>

## Pushing

<pre><code data-trim class="bash">
# Push changes in your LOCAL REPOSITORY to a REMOTE REPOSITORY
$: git push

# New branches have to be pushed explicitly
$: git push -u origin branch_name

# Tags as well
$: git push tagname  # single tag
$: git push --tags  # all tag
</code></pre>

- "origin" is an alias for your UPSTREAM REPOSITORY URL
- See [External Repos](#/external) for how to set up an UPSTREAM REPOSITORY
- Learn more about [Branches](#/branch_1) and [Tags](#/tag)

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/cat-727266_1280.jpg" id="realms">
<!-- https://pixabay.com/photos/cat-family-pet-love-happy-animal-727266/ -->
<textarea data-template>

## The 5 Holy Realms of git

<ul>
  <li><b>workspace</b>&nbsp;&nbsp;📂</li>
  <ul>
    <li>Your filesystem</li>
  </ul>
  <li class="fragment"><b>index</b>&nbsp;&nbsp;🕒
    <ul>
      <li>Staging area</li>
      <li>Files wait patiently to be committed</li>
    </ul>
  </li>
  <li class="fragment"><b>local repository</b>&nbsp;&nbsp;🗂️
    <ul>
      <li>Contains branches, commits, history, etc.</li>
    </ul>
  </li>
  <li class="fragment"><b>upstream repository</b>&nbsp;&nbsp;☁️
    <ul>
      <li>Cloud or self-hostet Git{Hub,Lab}</li>
      <li>Shared folder</li>
    </ul>
  </li>
  <div class="fragment">
  <hr>
  <li><b>stash</b>&nbsp;&nbsp;📦
    <ul>
      <li>Temporary storage area</li>
    </ul>
  </li>
  </div>
<ul>

Notes:
Most important slide of today

Upstream Repo in a minute

</textarea>
</section>
</section>

<section>
<section data-markdown data-state="standard 7" data-background="./files/barber-shop-5212059_1280.jpg" id="everyday">
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

# Everyday git

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/barber-shop-5212059_1280.jpg" id="status">
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

## Status

<pre data-id="code-animation" style="font-size: large; width: 70%;"><code data-trim class="bash"><script type="text/template">
$: git status         
On branch main
Your branch is up to date with 'origin/main'.

Changes to be committed:
  (use "git restore --staged <file>..." to unstage)
	modified:   00_title.md

Changes not staged for commit:
  (use "git add/rm <file>..." to update what will be committed)
  (use "git restore <file>..." to discard changes in working directory)
	modified:   index.html
	deleted:    slides/environments/reveal.js

Untracked files:
  (use "git add <file>..." to include in what will be committed)
	slides/advanced_git/
</script></code></pre>

- Which files are staged (to be commited)?
- Which files are changed, but not staged?
- Which files are not tracked?
- You will use this very often!

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/barber-shop-5212059_1280.jpg" id="rm">
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

## (Re)move Stuff


<pre data-id="code-animation"><code data-trim class="bash">
    rm file.txt                    # delete files from your WORKSPACE
    mv file_2.txt file_3.txt       # move or rename files in your WORKSPACE
</code></pre>


<pre data-id="code-animation"><code data-trim class="bash">
    rm file.txt                    # delete files from your WORKSPACE
    mv file_2.txt file_3.txt       # move files in your WORKSPACE
    git add file.txt               # ... and your INDEX
    git add file_2.txt file_3.txt  # ... and your INDEX
</code></pre>

<pre data-id="code-animation"><code data-trim class="bash">
    git rm file.txt                # Shorthand for rm X & git add X
    git mv file_2.txt file_3.txt   # Shorthand for mv X & git add X
</code></pre>


- "git add" does not add files to the **index**, but _changes_
- The _change_ of removing a file from the **workspace** must be _added_ to the **index**

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/barber-shop-5212059_1280.jpg" id="gitignore">
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

## Ignore stuff
.gitignore is a file in the root of your project
<pre data-id="code-animation"><code data-trim class="bash">
$: cat .gitignore
  # don't track passwords.txt
  passwords.txt
  # ignore *.tmp files, notice that wildcards '*' work
  *.tmp
  # but _do_ keep track of important.tmp
  !important.tmp
  # ignore 'logs' directories _anywhere_
  **/logs
  # ignore debug-a.log ... debug-z.log
  debug-[a-z].log
</code></pre>

- Hide certain files from git
- They stay in your **workspace** ...
  - but out of **index**, **local repository**, **upstream repository**
- Examples: Passwords or API tokens, log files or temporary files

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/barber-shop-5212059_1280.jpg" id="external">
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

### External Repos

<pre data-id="code-animation"><code data-trim class="bash">
    # Add an UPSTREAM REPOSITORY to your LOCAL REPOSITORY
    git remote add origin git@gitlab.com:OleMussmann/my_project.git

    # Get repo from an UPSTREAM REPOSITORY, creating a LOCAL REPOSITORY
    git clone https://gitlab.com:OleMussmann/my_project.git  # or...
    git clone git@gitlab.com:OleMussmann/my_project.git

    # Get latest updates from the UPSTREAM REPOSITORY, and merge them
    git pull git@gitlab.com:OleMussmann/my_project.git
    # Which is shorthand for:
    # Get latest updates from the UPSTREAM REPOSITORY
    git fetch git@gitlab.com:OleMussmann/my_project.git
    # Merge the remote changes to your local branch
    git merge <current_branch> <origin/current_branch>

    # Push changes from your LOCAL REPOSITORY to the UPSTREAM REPOSITORY
    git push git@gitlab.com:OleMussmann/my_project.git
</code></pre>


- Always "git pull" before working on a shared repo!
  - Conflicting changes in both **local repository** and **upstream repository** introduces _merge conflicts_

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/barber-shop-5212059_1280.jpg" data-transition="none">
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

## Branches 1/2

![Branches](./files/branches_1.svg)

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/barber-shop-5212059_1280.jpg" data-transition="none">
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

Notes: Branches are alternate realities


## Branches 1/2

![Branches](./files/branches_2.svg)

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/barber-shop-5212059_1280.jpg" data-transition="none">
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

## Branches 1/2

![Branches](./files/branches_3.svg)

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/barber-shop-5212059_1280.jpg" data-transition="none">
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

## Branches 1/2

![Branches](./files/branches_4.svg)

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/barber-shop-5212059_1280.jpg" id="branch_1"  data-transition="none">
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

## Branches 1/2

![Branches](./files/branches_5.svg)

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/barber-shop-5212059_1280.jpg" id="branch_2">
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

## Branches 2/2

<pre data-id="code-animation"><code data-trim class="bash" data-line-numbers="1-4|6-10|12-17|19-23|25-26">
$: git branch                         # list existing branches
    existing_branch
  * main
    old_branch
&nbsp;
$: git switch existing_branch         # switch to an existing branch
$: git branch
  * existing_branch
    main
    old_branch
&nbsp;
$: git switch -c new_feature_branch # c_reate (and switch to) branch
$: git branch
    existing_branch
    main
  * new_feature_branch
    old_branch
&nbsp;
$: git branch -d old_branch           # d_elete a branch
$: git branch
    existing_branch
    main
  * new_feature_branch
&nbsp;
# new branches have to be explicitly pushed to a remote:
$: git push -u origin new_feature_branch  # u_pstream: origin
</code></pre>

<ul class="fragment">
  <li>origin is an alias for the UPSTREAM REPOSITORY URL</li>
</ul>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/barber-shop-5212059_1280.jpg" id="branch_style">
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

## Branch Style

- Use "main" instead of "master" for your main branch
- Don't commit directly to "main"
  - "main" will be what users will clone and should be stable
- Use a "development" branch for daily work
  - Merge to "main", once stable
- Use feature branches for developing features
  - Merge to "development"
- Use descriptive branch names

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/barber-shop-5212059_1280.jpg" data-auto-animate >
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

## Detached HEAD 🤕

<pre data-id="code-animation-1"><code data-trim class="bash" data-line-numbers="1">
$: 
&nbsp;
&nbsp;
&nbsp;
</code></pre>

<pre data-id="code-animation-2"><code data-trim class="bash">
          "v1.0"
            |
main (m1)--(m2)--(m3)
                  |
                 HEAD # default, HEAD points to the tip of "main"
&nbsp;
&nbsp;
</code></pre>

- Usually HEAD is a pointer to the tip of a branch

<div>
<br>
<br>
<br>
<br>
</div>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/barber-shop-5212059_1280.jpg" data-auto-animate >
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

## Detached HEAD 🤕

<pre data-id="code-animation-1"><code data-trim class="bash" data-line-numbers="1">
$: git switch --detach v1.0  # notice the mandatory --detach flag
&nbsp;
&nbsp;
&nbsp;
</code></pre>

<pre data-id="code-animation-2"><code data-trim class="bash">
          "v1.0"
            |
main (m1)--(m2)--(m3)
            |
           HEAD (detached)  # sounds worse than it is
&nbsp;
&nbsp;
</code></pre>

- Usually HEAD is a pointer to the tip of a branch
- But when switching to commit hashes or tags,<br>the HEAD is "detached" 

<div>
<br>
<br>
</div>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/barber-shop-5212059_1280.jpg" data-auto-animate >
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

## Detached HEAD 🤕

<pre data-id="code-animation-1"><code data-trim class="bash" data-line-numbers="2">
$: git switch --detach v1.0  # notice the mandatory --detach flag
$: edit files; git add .; git commit -m "edited stuff";
&nbsp;
&nbsp;
</code></pre>

<pre data-id="code-animation-2"><code data-trim class="bash">
          "v1.0"
            |
main (m1)--(m2)--(m3)
             \
             (x1)  # ephemeral, "virtual" branch
              |
             HEAD (detached)
</code></pre>

- Usually HEAD is a pointer to the tip of a branch
- But when switching to commit hashes or tags,<br>the HEAD is "detached" 
- Edits that you make now would be lost

<div>
<br>
</div>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/barber-shop-5212059_1280.jpg" data-auto-animate >
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

## Detached HEAD 🤕

<pre data-id="code-animation-1"><code data-trim class="bash" data-line-numbers="3">
$: git switch --detach v1.0  # notice the mandatory --detach flag
$: edit files; git add .; git commit -m "edited stuff";
$: edit more; git add .; git commit -m "edited more";
&nbsp;
</code></pre>

<pre data-id="code-animation-2"><code data-trim class="bash">
          "v1.0"
            |
main (m1)--(m2)--(m3)
             \
             (x1)--(x2)  # ephemeral, "virtual" branch
                    |
                   HEAD (detached)
</code></pre>

- Usually HEAD is a pointer to the tip of a branch
- But when switching to commit hashes or tags,<br>the HEAD is "detached" 
- Edits that you make now would be lost

<div>
<br>
</div>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/barber-shop-5212059_1280.jpg" id="detached" data-auto-animate >
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

## Detached HEAD 🤕

<pre data-id="code-animation-1"><code data-trim class="bash" data-line-numbers="4">
$: git switch --detach v1.0  # notice the mandatory --detach flag
$: edit files; git add .; git commit -m "edited stuff";
$: edit more; git add .; git commit -m "edited more";
$: git switch -c "new_branch"
</code></pre>

<pre data-id="code-animation-2"><code data-trim class="bash">
          "v1.0"
            |
main (m1)--(m2)--(m3)
             \
new_branch   (n1)--(n2)  # proper branch, will go down in history
                    |
                   HEAD
</code></pre>

- Usually HEAD is a pointer to the tip of a branch
- But when switching to commit hashes or tags,<br>the HEAD is "detached" 
- Edits that you make now would be lost
- Creating a new branch re-attaches the HEAD


</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/barber-shop-5212059_1280.jpg" id="merge">
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

## Merge
<pre data-id="code-animation"><code data-trim class="bash">
    git switch -c new_feature_branch   # c_reate (and switch to) new branch
    # do things on new_branch, like adding and committing
    git switch main                    # switch to target branch
    git merge new_feature_branch       # merge new_feature_branch into main
</code></pre>

- git v2.23 instroduces 'git switch' and 'git restore'
  - They replace 'git checkout'

<footer><a href="https://stackoverflow.com/questions/1838873/visualizing-branch-topology-in-git">Visualizing branch topology in Git</a></footer>

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/barber-shop-5212059_1280.jpg" data-transition="none">
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

## Tags 1/2
#### Label your commits 🏷️

![Branches](./files/branches_5.svg)

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/barber-shop-5212059_1280.jpg" id="tag" data-transition="none">
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

## Tags 1/2
#### Label your commits 🏷️

![Branches](./files/branches_all.svg)

</textarea>
</section>

<section data-markdown data-state="standard" data-background="./files/barber-shop-5212059_1280.jpg" id="tag_2">
<!-- https://pixabay.com/photos/barber-shop-iran-cosmetology-5212059/ -->
<textarea data-template>

## Tags 2/2

<pre><code data-trim class="bash">
$: git tag                           # show all tags
  v1.0
  v1.1
$: git tag -a v1.2 -m "new gui"      # a_nnotated tag with a m_essage
$: git tag found_bug_in_this_commit  # lightweight tag: bookmarks
$: git push origin v1.2              # push a single tag
$: git push --tags                   # or push all tags
</code></pre>

<pre><code data-trim class="bash">
$: git switch --detach v1.0          # detach head and switch to a tag
</code></pre>

- Annotated tags contain lots of metadata<br>
  Use them for actual tagging
- Lightweight tags are bookmarks<br>
  Use them as personal bookmarks
- You can switch to tags, [detaching the HEAD](#/detached)

</textarea>
</section>
</section>

<section>
<section data-markdown data-state="standard 5" data-background="./files/religion-3491357_1280.jpg" id="advanced">
<!-- https://pixabay.com/photos/religion-meditation-faith-light-3491357/ -->
<textarea data-template>

# Advanced git

</textarea>
</section>

<section data-markdown data-state="standard 7" data-background="./files/religion-3491357_1280.jpg" id="status_2">
<!-- https://pixabay.com/photos/religion-meditation-faith-light-3491357/ -->
<textarea data-template>

## Advanced Status 1/2

<h4>Differences</h4>

<pre style="font-size: x-large;"><code data-trim class="bash"><script type="text/template">
git diff file.txt                   # WORKSPACE - INDEX
git diff <commit> file.txt          # WORKSPACE - COMMIT HASH
git diff HEAD file.txt              # WORKSPACE - LOCAL REPO (COMMIT H. = HEAD)
git diff --staged file.txt          # INDEX - LOCAL REPO (HEAD)
git diff --staged <commit> file.txt # INDEX - COMMIT HASH
</script></code></pre>

<pre style="font-size: x-large;"><code data-trim class="bash"><script type="text/template">
$: git diff      # Omit filename to show _all_ changed files
diff --git a/file.txt b/file.txt
index 00dedf6..02ef113 100644
--- a/file.txt   # old version
+++ b/file.txt   # new version
@@ -1 +1 @@      # one line changed
-abcde           # removed lines
+new line here!  # added lines
</script></code></pre>

</textarea>
</section>

<section data-markdown data-state="standard 7" data-background="./files/religion-3491357_1280.jpg" id="status_3">
<!-- https://pixabay.com/photos/religion-meditation-faith-light-3491357/ -->
<textarea data-template>

## Advanced Status 2/2

<div style="width: 53%; float: left;">
<h4>Commit history</h4>

<pre style="font-size: medium"><code data-trim class="bash"><script type="text/template">
    # try tab completion, a file name or a commit hash!
    $: git log
    # HEAD points to the latest commit in the LOCAL REPOSITORY
    commit 0fb599d96521bd27b05b0a6f963ba6ab903d349c (HEAD -> main)
    Author: ole <gitlab+account@ole.mn>
    Date:   Mon Jun 13 11:07:30 2022 +0200
    
        add content to README
    
    commit 89d8a1b57f2440693aff2f7b5003201836aa24d4
    Author: ole <gitlab+account@ole.mn>
    Date:   Mon Jun 13 11:06:51 2022 +0200
    
        create README.md
    &nbsp;
    &nbsp;
</script></code></pre>
</div>

<div style="width: 46%; float: right;">
<h4>Show commits</h4>

<pre style="font-size: medium;"><code data-trim class="bash"><script type="text/template">
    # try tab completion, a branch, tag or a commit hash!
    $: git show 0fb5  # four hash characters are enough
    commit 0fb599d96521bd27b05b0a6f963[...] (HEAD -> main)
    Author: ole <gitlab+account@ole.mn>
    Date:   Mon Jun 13 11:07:30 2022 +0200
    
        add content to README
    
    diff --git a/README.md b/README.md
    index e69de29..8824ebc 100644
    --- a/README.md
    +++ b/README.md
    @@ -0,0 +1,3 @@
    +Hi! I am a README file.
    +
    +I have content.
</script></code></pre>
</div>

<h4>Blaming!<br>
(... or "who changed a file"?)</h4>
<pre style="font-size: medium; width: 50%;"><code data-trim class="bash"><script type="text/template">
# try tab completion or a file name!
$: git blame file.txt
e546a240 (ole 2022-06-10 11:12:27 +0200 1) new line here!
682bc7ca (ole 2022-06-10 11:19:20 +0200 2) and another one
a9a390b3 (ole 2022-06-10 11:20:05 +0200 3) many
a9a390b3 (ole 2022-06-10 11:20:05 +0200 4) more lines
</script></code></pre>


</textarea>
</section>

<section data-markdown data-state="standard 7" data-background="./files/religion-3491357_1280.jpg" id="stash">
<!-- https://pixabay.com/photos/religion-meditation-faith-light-3491357/ -->
<textarea data-template>

## Stash 1/2
#### Putting things away temporarily

<pre><code data-trim class="bash"><script type="text/template">
$: git status         
  On branch main
  Changes to be committed:
    (use "git restore --staged <file>..." to unstage)
  	new file:   staged_file
&nbsp;
  Untracked files:
    (use "git add <file>..." to include in what will be committed)
  	workspace_file
  &nbsp;
$: git stash -u  # Optional -u to include u_ntracked files
  Saved working directory and index state WIP on main: [...]
&nbsp;
$: git status
  On branch main
  nothing to commit, working tree clean
</script></code></pre>

</textarea>
</section>

<section data-markdown data-state="standard 7" data-background="./files/religion-3491357_1280.jpg" id="stash_2">
<!-- https://pixabay.com/photos/religion-meditation-faith-light-3491357/ -->
<textarea data-template>

## Stash 2/2
#### Retrieving things

<pre><code style="height: 14em;" data-trim class="bash" data-line-numbers="1-3|5-6|5-6,8|5-6,9|5-6,10|10-18"><script type="text/template">
$: git status
  On branch main
  nothing to commit, working tree clean
&nbsp;
$: git stash list
  stash@{0}: WIP on main: 50f8199 add committed_file  # only one item
&nbsp;
$: git stash apply stash@\{0\} # Omit stash name for latest
$: git stash apply             # Use latest stash
$: git stash apply --index     # Optional --index to also apply INDEX
  On branch main
  Changes to be committed:
    (use "git restore --staged <file>..." to unstage)
  	new file:   staged_file
&nbsp;
  Untracked files:
    (use "git add <file>..." to include in what will be committed)
  	workspace_file
</script></code></pre>

Conflicting changes since the stashing might might create [merge conflicts](#/conflicts). You can make a branch instead and work from there:

<pre><code data-trim class="bash" data-line-numbers=""><script type="text/template">
# Omit stash name for latest
$: git stash branch new_stash_branch stash@\{0\}
</script></code></pre>

</textarea>
</section>

<section data-markdown data-state="standard 7" data-background="./files/religion-3491357_1280.jpg" id="conflicts">
<!-- https://pixabay.com/photos/religion-meditation-faith-light-3491357/ -->
<textarea data-template>

## Merge Conflicts

- Merge conflicts occur when you try to merge a branch/stash that conflicts with your local version, e.g.
  - Overlapping edits in the same file (obvious)
  - Win vs Linux file endings, tabs to spaces (invisible)

<br>
<br>

1. Don't panic! You can always abort the merge
1. Git gives you helpful error messages and the tools to resolve the conflicts
1. You are not the first one to encounter that specific error, google and stackoverflow are your friend

</textarea>
</section>

<section data-markdown data-state="standard 7" data-background="./files/religion-3491357_1280.jpg" id="redneck">
<!-- https://pixabay.com/photos/religion-meditation-faith-light-3491357/ -->
<textarea data-template>

## Redneck Style

Don't tell anyone you've got this from me... 🙊 But this is a totally viable strategy. Here we go.

<ul class="fragment">
  <li>Do a fresh git clone into a <b>separate folder</b></li>
  <li>Work in your changes</li>
  <li>Push your changes</li>
  <li>Delete your original folder (optional)</li>
<ul>

</textarea>
</section>

<section data-markdown data-state="standard 7" data-background="./files/religion-3491357_1280.jpg" id="by_hand" data-auto-animate >
<!-- https://pixabay.com/photos/religion-meditation-faith-light-3491357/ -->
<textarea data-template>

## By Hand

<pre><code style="font-size: large; height: 30em;" data-trim class="r" data-line-numbers="1-7|9-23|25-39|41-50|52-60">
$: git pull  # Oh no, a merge conflict! (Don't panic, I've got this.)
  [...]
  From https://renkulab.io/gitlab/renkuaccount/git
     c297618..09f2cc8  main       -> origin/main
  Auto-merging file.txt
  CONFLICT (content): Merge conflict in file.txt
  Automatic merge failed; fix conflicts and then commit the result.
&nbsp;
$: git status  # git status shows me what's wrong
  On branch main
  Your branch and 'origin/main' have diverged,
  and have 1 and 1 different commits each, respectively.
    (use "git pull" to merge the remote branch into yours)  # Not so helpful, it failed
&nbsp;
  You have unmerged paths.
    (fix conflicts and run "git commit")  # Helpful!
    (use "git merge --abort" to abort the merge)  # Panic button, good to know
&nbsp;
  Unmerged paths:
    (use "git add <file>..." to mark resolution)  # git assumes i'm happy after 'add'
          both modified:   file.txt
&nbsp;
  no changes added to commit (use "git add" and/or "git commit -a")
&nbsp;
$: git diff  # git diff shows me affected lines (phew, does not look too bad 😅)
  diff --cc file.txt
  index 2054524,f15ccdf..0000000
  --- a/file.txt
  +++ b/file.txt
  @@@ -1,5 -1,5 +1,9 @@@  # merged lines 1-5 ("file a"), 1-5 ("file b") to lines 1-9 ("file c") ?!
    text text
    all the same everywhere
  ++<<<<<<< HEAD               # Diff start
   +line edited locally        # Part from HEAD ("file a")
  ++=======                    # Separator
  + line edited on remote      # Part from remote ("file b") (commit hash 09f2c[...])
  ++>>>>>>> 09f2cc8e449905494d3ca61d78c5b071d62db1cf  # Diff end
    more same lines
    no conflicts down here
&nbsp;
$: cat file.txt  # Looking at the file.txt content. Aha! This is "file c"
  text text
  all the same everywhere
  <<<<<<< HEAD              # I should remove these control lines
  line edited locally       # I can keep this line ...
  =======                   # (remove)
  line edited on remote     # ... or this line. In fact, I can edit the file however I want!
  >>>>>>> 09f2cc8e449905494d3ca61d78c5b071d62db1cf  # (remove)
  more same lines
  no conflicts down here
&nbsp;
$: [edit file.txt, fix conflicting lines, remove control lines]
&nbsp;
$: git add file.txt
&nbsp;
$: git commit -m "resolve merge conflict"
  [main 0835b22] resolve merge conflict
&nbsp;
$: git push  # All clear! 😃
  [...]
</code></pre>

</textarea>
</section>

<section data-markdown data-state="standard 7" data-background="./files/religion-3491357_1280.jpg" id="mergetool_1" >
<!-- https://pixabay.com/photos/religion-meditation-faith-light-3491357/ -->
<textarea data-template>

## With a mergetool: vimdiff

<pre style="width: max-content;"><code data-trim class="bash"><script type="text/template">
    git mergetool --tool=vimdiff
</script></code></pre>

<img style="height: 22vh;" src="./files/vimdiff.png">

- Also show LOCAL, BASE (best common ancestor), REMOTE
- vim is about everywhere
- Challenging to learn, hard to master, worth knowing basics!

</textarea>
</section>

<section data-markdown data-state="standard 7" data-background="./files/religion-3491357_1280.jpg" id="mergetool_2" >
<!-- https://pixabay.com/photos/religion-meditation-faith-light-3491357/ -->
<textarea data-template>

## With a mergetool: meld

<pre style="width: max-content;"><code data-trim class="bash"><script type="text/template">
    git mergetool --tool=meld
</script></code></pre>

<img style="height: 22vh;" src="./files/meld.png">

- Merge to "best common ancestor" (middle)
- GUI tools like meld are more intuitive
- Not available in CLI environments

</textarea>
</section>
</section>

<section>
<section data-markdown data-state="standard 7" data-background="./files/clock-1527693_1280.jpg" id="undo">
<!-- https://pixabay.com/illustrations/clock-clock-face-waves-present-1527693/ -->
<textarea data-template>

# Turn Back Time

</textarea>
</section>

<section data-markdown data-state="standard 9" data-background="./files/clock-1527693_1280.jpg" id="undo_1">
<!-- https://pixabay.com/illustrations/clock-clock-face-waves-present-1527693/ -->
<textarea data-template>

## Undo 1/4: Commit One More
<pre><code data-trim class="bash" data-line-numbers="1-2|3|4"><script type="text/template">
# No need to commit yet again! Make amends instead.
git commit -m "this should be all files"
git add dang_i_forgot_this_one.txt
git commit --amend -m "this should be all files"  # same commit!
</script></code></pre>

(Don't push in between...)

</textarea>
</section>

<section data-markdown data-state="standard 9" data-background="./files/clock-1527693_1280.jpg" id="undo_2">
<!-- https://pixabay.com/illustrations/clock-clock-face-waves-present-1527693/ -->
<textarea data-template>

## Undo 2/4: Restore to WORKSPACE

<pre style="font-size: x-large;"><code data-trim class="bash" data-line-numbers="1-3|4-5|6-8|9|10-15|16-17|18-19"><script type="text/template">
$: ls
  EDIT.txt
  DELETE.txt
$: git add .
$: git commit -m "add files"
$: rm DELETE.txt  # remove from WORKSPACE but not INDEX!
$: ls
  EDIT.txt
# edit EDIT.txt
$: git status
  Changes not staged for commit:
    (use "git add/rm <file>..." to update what will be committed)
    (use "git restore <file>..." to discard changes in working directory)
          deleted:  DELETE.txt
          modified: EDIT.txt
$: git restore EDIT.txt 
$: git restore DELETE.txt
$: ls
  DELETE.txt  EDIT.txt
</script></code></pre>

You can even "restore" files from another branch or the stash

<pre style="font-size: x-large;"><code data-trim class="bash"><script type="text/template">
$: git restore --source stash_name/branch_name filename
</script></code></pre>

</textarea>
</section>

<section data-markdown data-state="standard 9" data-background="./files/clock-1527693_1280.jpg" id="undo_3">
<!-- https://pixabay.com/illustrations/clock-clock-face-waves-present-1527693/ -->
<textarea data-template>

## Undo 3/4: Un-stage from INDEX

<pre style="font-size: x-large;"><code data-trim class="bash" data-line-numbers="1-6|7-8|9-17"><script type="text/template">
$: git status
  [...]
  Changes to be committed:
    (use "git rm --cached <file>..." to unstage)
  	new file:   SENSITIVE_PASSWORDS.txt  # Uh oh!
  	new file:   README.md
$: git rm --cached SENSITIVE_PASSWORDS.txt
  rm 'PASSWORDS.txt'
$: git status                   
  [...]
  Changes to be committed:
    (use "git rm --cached <file>..." to unstage)
  	new file:   README.md
  &nbsp;
  Untracked files:
    (use "git add <file>..." to include in what will be committed)
  	SENSITIVE_PASSWORDS.txt
</script></code></pre>

- <code style="font-size: smaller;">git rm --cached [file]&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code>remove from INDEX
- <code style="font-size: smaller;">git restore --staged [file]&nbsp;</code>copy from HEAD to INDEX

</textarea>
</section>

<section data-markdown data-state="standard 9" data-background="./files/clock-1527693_1280.jpg" id="undo_4">
<!-- https://pixabay.com/illustrations/clock-clock-face-waves-present-1527693/ -->
<textarea data-template>

## Undo 4/4: Rewriting history 📜

**⚠️ WARNING! ⚠️** You are playing with fire 🔥

- This is especially dangerous if other people based their work on your commits.
- It's possible to do it with only git commands ...
- ... but it's safer to use third-party tools, like git-filter-repo
  - https://github.com/newren/git-filter-repo/
- Use it to remove accidentally pushed passwords or API keys

</textarea>
</section>
</section>

<section data-markdown data-state="standard 4" data-background="./files/note-pad-1215425_1920.jpg" id="summary">
<!-- https://pixabay.com/illustrations/note-pad-pen-coffee-cup-plant-1215425/ -->
<textarea data-template>

<div style="transform: rotate(-5deg); width: 70%; float: left; margin-left: 4vw;">
  <h2 style="padding: 0; margin: 0;">Summary</h2>
  <ul style="padding-top: 0; margin-top: 0;">
    <li>Yes, git has a learning curve</li>
    <li>Master the basics, learn the rest as you go</li>
    <li>Make use of extensive, free resources</li>
    <li>Let git enable your own work and collaborations</li>
  </ul>
</div>

</textarea>
</section>

<section data-markdown data-state="logo yellow_flag black_overlay" data-background="./files/earth-3537401_1920.jpg" id="links">
<!-- https://pixabay.com/illustrations/earth-network-blockchain-globe-3537401/ -->
<textarea data-template>

# Resources

- _The_ authority, sleep with it under your pillow
  - https://git-scm.com/book/en/v2
- Interactive cheatsheet, which commands to use where
  - https://ndpsoftware.com/git-cheatsheet.html
<br>
<br>
- Rebase explained with ... music
  - https://www.youtube.com/watch?v=S9Do2p4PwtE

</textarea>
</section>

<section>
<section data-markdown data-state="logo yellow_flag black_overlay 6" data-background="./files/man-2264825_1920.jpg" id="exercise">
<!-- https://pixabay.com/photos/man-woman-push-ups-wellness-2264825/ -->
<textarea data-template>

# Exercise

</textarea>
</section>

<section data-markdown data-state="logo yellow_flag black_overlay 6" data-background="./files/man-2264825_1920.jpg" >
<!-- https://pixabay.com/photos/man-woman-push-ups-wellness-2264825/ -->
<textarea data-template>

### Nano, Command Line Editor 🤏

<img style="height: 30vh;" src="./files/nano.png"/>

- CTRL+O, ENTER to write to file
- CTRL+X to exit

</textarea>
</section>

<section data-markdown data-state="logo yellow_flag black_overlay 6" data-background="./files/man-2264825_1920.jpg" >
<!-- https://pixabay.com/photos/man-woman-push-ups-wellness-2264825/ -->
<textarea data-template>

### Zero to git: Local 👈


<div style="font-size: x-large;">

**Play with git on mybinder 🏑**

- <a href="https://mybinder.org/v2/gh/OleMussmann/git/HEAD"><img style="padding: 0; margin:0;" src="https://mybinder.org/badge_logo.svg"/></a> and wait for it to start
- Click on "Terminal"
- Configure git to your liking, set at least `user.name` and `user.email`, and set `pull.rebase false`
- Create a folder **git** and change into it: &nbsp; `mkdir git; cd git`
- Initialize a repo with trunk (main branch) _main_
- Create a file **README.md** and fill it with some markdown, this is in your WORKSPACE
- Add the file to your INDEX
- Commit the file to your LOCAL REPOSITORY
  - Name the commit "Initial Commit"

</div>

</textarea>
</section>

<section data-markdown data-state="logo yellow_flag black_overlay 6" data-background="./files/man-2264825_1920.jpg" >
<!-- https://pixabay.com/photos/man-woman-push-ups-wellness-2264825/ -->
<textarea data-template>

### Zero to git: Remote 🖩


<div style="font-size: x-large;">

**Connect with the World 🌍**

- Create an _empty_ repository on GitHub or GitLab
- Create SSH keys in your binder environment
  - Feel free to omit the password _for this exercise only_
- Configure SSH to use your new key for github.com
- Upload the SSH keys to GitHub or GitLab
- Test the SSH connection, confirm first connection attempt
- Add the new UPSTREAM REPOSITORY as remote named _origin_ to your local repo
- Push the main branch to the UPSTREAM REPOSITORY _origin_
- Check in the browser if the **README.md** arrived

Congratulations! 🎉 You have mastered the basics of git.
</div>

</textarea>
</section>

<section data-markdown data-state="logo yellow_flag black_overlay 6" data-background="./files/man-2264825_1920.jpg" >
<!-- https://pixabay.com/photos/man-woman-push-ups-wellness-2264825/ -->
<textarea data-template>

### Everyday git: Back and Forth ↔️

<div style="font-size: x-large;">

**Understanding the 5 Realms 🏰**

- ⚠️ After each of the following steps, check the status of the repo: &nbsp; `git status`
  - Create a few files
    - **committed.txt &nbsp; staged.txt &nbsp; edited.txt &nbsp; ignored.txt**
  - Add and commit **committed.txt** and **edited.txt**
  - Edit (but not add or commit!) **edited.txt**
  - Add (but not commit!) **staged.txt**
  - Create a file **.gitignore** and use it to exclude the file **ignored.txt**
  - Add and commit **.gitignore** and all the other files and push your LOCAL REPOSITORY to the REMOTE REPOSITORY
- Check in the browser the state of your REMOTE REPOSITORY
- Delete all **\*.txt** files, add the changes, and commit your changes to _main_
- Push your changes to the REMOTE REPOSITORY
- Check the status with &nbsp; `git status`
- Create a file **from_remote.txt** on github.com, commit directly to _main_
- Pull the latest changes from the REMOTE REPOSITORY
- Inspect the local files with  &nbsp; `ls -a`
- Check the status with &nbsp; `git status`

</div>

</textarea>
</section>

<section data-markdown data-state="logo yellow_flag black_overlay 6" data-background="./files/man-2264825_1920.jpg" >
<!-- https://pixabay.com/photos/man-woman-push-ups-wellness-2264825/ -->
<textarea data-template>

### Everyday git: Branching Out 🎋

<div style="font-size: x-large;">

**Multi-dimensional ✨**

- Create and switch to a development branch called _development_
- Create, add to INDEX and commit a file **dev_stuff.txt**, name the commit "add dev stuff"
- Realize you were not done yet, create a file **more_dev_stuff.txt**
  - Add it to INDEX and commit it _to the same commit_ as **dev_stuff.txt** (make amends)
  - Name the commit "add dev stuff" as well
- Confirm that you have only one commit with `git log`
- "Accidentally" delete **dev_stuff.txt**
  - Don't worry, it's still saved in the LOCAL REPOSITORY! Restore it back to your WORKSPACE
- Create and add to INDEX a file **passwords.txt**
  - Realize it should not end up in the repo, and un-stage it from INDEX
  - Add it to the **.gitignore** file, just to be safe
  - Add all your changes and commit them
- Switch back to branch _main_
- Merge the branch _development_ into _main_
- If successful, tag the latest commit with an annotated tag "v1.0"
- Push the new branch and the tag to your REMOTE REPOSITORY _origin_

Yesss! 🥳 You are getting good at this.
</div>

</textarea>
</section>

<section data-markdown data-state="logo yellow_flag black_overlay 6" data-background="./files/man-2264825_1920.jpg" >
<!-- https://pixabay.com/photos/man-woman-push-ups-wellness-2264825/ -->
<textarea data-template>

### Advanced git: Stashing Things 📦

<div style="font-size: x-large;">

**Temporarily Cleaning Up 🧽**

- Create a **file.txt**, and fill it with the line "I'm in the REPO"
- Add it to INDEX and commit to your LOCAL REPOSITORY
- Edit the content of **file.txt** to "And now I'm in INDEX"
- Add the file to INDEX
- Edit the file again and change the content to "Or in WORKSPACE?"
  - The file has now three different contents in three different places 😮
- Apply the `git diff` commands that show the differences of **file.txt** in
  - WORKSPACE ↔ INDEX
  - WORKSPACE ↔ LOCAL REPO
  - INDEX ↔ LOCAL REPO
- See what files you have now: &nbsp; `ls -a`
- Check the state of your local repo: &nbsp; `git status`
- Stash the mess you just created, including the untracked (not staged in INDEX) files
- See again what files you have now: &nbsp; `ls -a`
- Check again the state of your local repo: &nbsp; `git status`
- Re-apply the stash, _including the INDEX_
- Confirm that you have everything back, WORKSPACE, INDEX

</div>

</textarea>
</section>

<section data-markdown data-state="logo yellow_flag black_overlay 6" data-background="./files/man-2264825_1920.jpg" >
<!-- https://pixabay.com/photos/man-woman-push-ups-wellness-2264825/ -->
<textarea data-template>

### Advanced git: Gaining Insight 👓

<div style="font-size: x-large;">

**Take a breather and study what you did 😌**

- Study what you have done in the repo so far: &nbsp; `git log`
- See what's inside the tag "v1.0": &nbsp; `git show v1.0`
- Find out (and blame) who made a mess with **file.txt**: `git blame file.txt`
  - Change, add and commit file.txt a few more times and do it again
  - Also check with `git log file.txt`
- See the last change of **file.txt**: &nbsp; `git show file.txt`

Take a break (if you haven't yet), get a coffee ☕ and prepare for the finale
</div>

</textarea>
</section>

<section data-markdown data-state="logo yellow_flag black_overlay 6" data-background="./files/man-2264825_1920.jpg" >
<!-- https://pixabay.com/photos/man-woman-push-ups-wellness-2264825/ -->
<textarea data-template>

### git Enlightenment: Conflict Resolution 🕊️

<div style="font-size: x-large;">

**The Final Frontier 🚀**

- Switch to the _main_ branch, if you didn't already
- Add, commit and push all changes, start with a clean LOCAL REPOSITORY
- Create, add and commit a file **poem.txt**, containing my bad poem
- Push the LOCAL REPOSITORY to your REMOTE REPOSITORY _origin_
- Fix the poem in the browser in your REMOTE REPOSITORY, commit to _main_
- Fix the poem _differently_ in your LOCAL REPOSITORY, add and commit to _main_
- Pull the remote changes
- Resolve the merge conflict
  - The mergetool "vimdiff" uses CTRL-W to switch between panes, this collides with the browser shortcut to close windows; resolve the conflict "by hand" instead

Amazing! You made it. 🏅 You probably fought with JupyterLab, wrestled git, fixed unexpected errors, and still pulled through. You are ready to use git effectively in your own projects.

Keep learning and enjoy the journey.
</div>

</textarea>
</section>
</section>
      </div>
    </div>

    <script src="dist/reveal.js"></script>

    <script src="plugin/highlight/highlight.js"></script>
    <script src="plugin/markdown/markdown.js"></script>
    <script src="plugin/math/math.js"></script>
    <script src="plugin/notes/notes.js"></script>
    <script src="plugin/search/search.js"></script>
    <script src="plugin/zoom/zoom.js"></script>
    <!--
    <script src="reveal.js/4.3.1/reveal.js-plugins/menu/menu.js"></script>
    -->

    <script src="dist/escience.js"></script>

    <script>
      // More info about initialization & config:
      // - https://revealjs.com/initialization/
      // - https://revealjs.com/config/
      Reveal.initialize({
        hash: true,

        // Automatically activate the scroll view when we the viewport falls
        // below the given width.
        scrollActivationWidth: 0,  // disabled

        // Force the scrollbar to remain visible
        scrollProgress: true,

        // Learn about plugins: https://revealjs.com/plugins/
        plugins: [ RevealMarkdown, RevealHighlight, RevealNotes ]
      });
    </script>
  </body>
</html>
